#include<cstdlib>
#include<iostream>
#include<vector>
#include<algorithm>
#include<functional>
#include<numeric>

int consecutiveNumber() {
  static int counter = 0;
  return ( counter++ );
}

class UniqueNumberGenerator {
public:
  UniqueNumberGenerator() : _num ( 0 ) {
  }

  int operator()() {
    _num += 3;
    return ( _num );
  }

private:
  int _num;
};


template<typename ContainerType>
void printContainer ( const ContainerType &Arg ) {
  for ( auto it = Arg.begin(); it != Arg.end(); ++it ) {
    std::cout << *it << " ";
  }
  std::cout << std::endl;
}


int main ( const int, const char** const ) {
  const size_t mySize = 10;
  std::vector<int> myVectorA ( mySize );
  std::generate ( myVectorA.begin(), myVectorA.end(), consecutiveNumber );
  printContainer ( myVectorA );

  std::vector<int> myVectorB ( mySize );
  std::generate ( myVectorB.begin(), myVectorB.end(), UniqueNumberGenerator() );
  printContainer ( myVectorB );

  std::vector<int> myVectorC ( mySize );
  std::transform ( myVectorA.begin(), myVectorA.end(), myVectorB.begin(), myVectorC.rbegin(), std::plus<int>() );
  printContainer ( myVectorC );

  const int
    init = 50,
    result = std::accumulate ( myVectorA.begin(), myVectorA.end(), init, std::minus<int>() );
  std::cout << "result = " << result << std::endl;
  return ( EXIT_SUCCESS );
}
