#include<cstdlib>
#include<iostream>
#include<list>
#include<vector>

typedef signed int IntType;

template<typename ContainerType>
void fillWithSomeValues ( ContainerType& Arg ) {
  const size_t mySize = 20;
  for ( size_t i = 0; i < mySize; ++i ) {
    Arg.push_back ( static_cast<IntType> ( ( 12 * i ) % 27 ) );
  }
}

template<typename ContainerType>
void printContents ( ContainerType& Arg ) {
  // this works for both vector and list (and others)
  for ( typename ContainerType::const_iterator it = Arg.begin(); it != Arg.end(); ++it ) {
    std::cout << *it << " ";
  }
  std::cout << std::endl;
}

int main ( const int, const char** const ) {
  std::vector<IntType> myVector;
  fillWithSomeValues ( myVector );
  printContents ( myVector );

  std::list<IntType> myList;
  fillWithSomeValues ( myList );
  printContents ( myList );

  return ( EXIT_SUCCESS );
}
