#include<cstdlib>
#include<iostream>
#include<list>

template<typename ListType>
void fillWithSomeData ( ListType &Arg ) {
  const unsigned int destSize = 10;
  for ( unsigned int i = 0; i < destSize; ++i ) {
    Arg.push_front ( 42*i+23 );
  }
}

void fillWithSomeOtherData ( std::list<signed long int> &Arg ) {
  const unsigned int destSize = 7;
  for ( unsigned int i = 0; i < destSize; ++i ) {
    Arg.push_back ( 21*i+23 );
  }
}


template<typename ContainerType>
void printContainer ( const ContainerType &Arg ) {
  for ( auto it = Arg.begin(); it != Arg.end(); ++it ) {
    std::cout << *it << " ";
  }
  std::cout << std::endl;
}

struct isOdd {
  template<typename IntegerType>
  bool operator() ( const IntegerType &Value ) {
    return ( ( Value % 2 ) == 1 );
  }
};



int main ( const int, const char** const ) {
  std::list<signed long int> myListA, myListB;

  fillWithSomeData ( myListA );
  fillWithSomeOtherData ( myListB );

  std::list<signed long int>::iterator myIt = myListA.begin();
  std::advance ( myIt, 3 );

  printContainer ( myListA );
  printContainer ( myListB );

  myListA.splice ( myIt, myListB );

  printContainer ( myListA );

  myListA.sort();

  printContainer ( myListA );

  myListA.remove ( 65 );

  printContainer ( myListA );

  myListA.unique();

  printContainer ( myListA );

  myListA.remove_if ( isOdd() );

  printContainer ( myListA );

  return ( EXIT_SUCCESS );
}
