#include<cstdlib>
#include<iostream>
#include<list>


int main ( const int, const char** const ) {
  std::list<unsigned int> myList; // no size

  for ( int i = 0; i < 12; ++i ) {
    myList.push_back ( 4 * i + 3 );
  }

  // note: no random access

  std::cout << "myList is of size " << myList.size() << std::endl;

  // iterate over list
  //   note the "auto" keyword (C++ 11)
  for ( auto it = myList.begin(); it != myList.end(); ++it ) {
    std::cout << *it << std::endl;
  }

  std::list<unsigned int>::iterator it = myList.begin();
  ++it; ++it;

  myList.insert ( it, 21859275 ); // insert new entry before
                                  // this is cheaper than for vectors

  --it;
  std::cout << *it << std::endl;

  myList.erase ( it );

  myList.push_front ( 4711 );
  myList.push_back ( 28359 );

  myList.pop_back();
  myList.pop_front();

  myList.clear(); // resize to 0

  return ( EXIT_SUCCESS );
}
