#include<cstdlib>
#include<iostream>
#include<map>
#include<string>

int main ( const int, const char** const ) {
  {
    std::map<short int, std::string> myMap;
    myMap[1] = "One"; // inserting elements works via operator[], but default create first
    myMap.insert ( std::pair<short int, std::string> ( 2, "Two" ) );
    myMap.insert ( std::make_pair ( 3, "Three" ) );

    std::cout << "1: " << myMap[1] << std::endl; // access also works via operator[]

    std::cout << "4: " << myMap[4] << std::endl; // there is no const access, default object created instead!

    auto it = myMap.find ( 1 );
    std::cout << it->first << " " << it->second << std::endl; // iterator points to pair

    it = myMap.find ( 5 );
    std::cout << ( it == myMap.end() ) << std::endl;
  }

  {
    std::map< std::string, short int>
      myOtherMap = { { "Zero ", 0 },
                     { "One  ", 1 },
                     { "Two  ", 2 },
                     { "Three", 3 },
                     { "Four ", 4 },
                     { "Five ", 5 },
                     { "Six  ", 6 },
                     { "Seven", 7 },
                     { "Eight", 8 },
                     { "Nine ", 9 } };
    // alternative form of initialization

    // this is how one can iterate over a map
    for ( auto it = myOtherMap.begin(); it != myOtherMap.end(); ++it ) {
      std::cout << it->first << " " << it->second << std::endl;
    }
    // note: the map is sorted
  }

  return ( EXIT_SUCCESS );
}
