#include<cstdlib>
#include<iostream>
#include<set>

int main ( const int, const char** const ) {
  std::set<short int> mySet;

  for ( int i = 0; i < 25; ++i ) {
    const short int val = ( 12 * i + 2 ) % 26;
    std::cout << "inserting " << val << std::endl;
    mySet.insert ( val );
  }

  std::cout << "mySet is of size " << mySet.size() << std::endl;
  // note: no random access

  std::cout << " Removed " << mySet.erase ( 12 ) << " times entry 12." << std::endl
            << " Removed " << mySet.erase ( 13 ) << " times entry 13." << std::endl;

  // iterate over set, as before
  //   note the "auto" keyword (C++ 11)
  for ( auto it = mySet.begin(); it != mySet.end(); ++it ) {
    std::cout << *it << std::endl;
  }

  std::set<short int>::iterator pos = mySet.find ( 16 );
  std::cout << "16 found: " << *pos << std::endl;

  std::set<short int>::iterator otherPos = mySet.find ( 23 );
  if ( otherPos == mySet.end() ) {
    std::cout << "the following results in undefined behavior" << std::endl;
    std::cout << "23 not found: " << *otherPos << std::endl; // dereferencing undefined!
  }

  return ( EXIT_SUCCESS );
}
