#include<cstdlib>
#include<iostream>
#include<set>
#include<unordered_set>
#include<string>

template<typename SetType>
void fillAndPrint ( ) {
  SetType mySet;

  for ( int i = 0; i < 25; ++i ) {
    const short int val = ( 12 * i + 2 ) % 26;
    std::cout << "inserting " << val << std::endl;
    mySet.insert ( val );
  }

  std::cout << "mySet is of size " << mySet.size() << std::endl;

  for ( auto it = mySet.begin(); it != mySet.end(); ++it ) {
    std::cout << *it << std::endl;
  }
  std::cout << std::endl;
}

int main ( const int, const char** const ) {
  std::cout << "Multiset: " << std::endl;
  fillAndPrint < std::multiset<short int> > ();

  std::cout << "Unordered Set: " << std::endl;
  fillAndPrint < std::unordered_set<short int> > ();

  std::cout << "Unordered Multiset: " << std::endl;
  fillAndPrint < std::unordered_multiset<short int> > ();

  std::unordered_set<std::string> myUnorderedSet;

  for ( int i = 0; i < 25; ++i ) {
    std::string number = "Number " + std::to_string ( i );
    std::cout << "inserting " << number << " with hash " << myUnorderedSet.hash_function() ( number ) << std::endl;
    myUnorderedSet.insert ( number );
  }

  std::cout << "Load factor is " << myUnorderedSet.load_factor() << ", there are " << myUnorderedSet.bucket_count() << " buckets." << std::endl;

  std::string num23 ( "Number 23" );
  std::cout << num23 << " is in bucket " << myUnorderedSet.bucket ( num23 ) << std::endl;

  return ( EXIT_SUCCESS );
}
