#include<cstdlib>
#include<iostream>
#include<list>
#include<limits>
#include<math.h>

// example for std::pair used for returning two objects by value
// also showing use of numeric_limits

template<typename T>
std::pair<T, unsigned int> findMaximumAndItsPosition ( std::list<T> &Arg ) {
  std::pair<T, unsigned int> res ( - std::numeric_limits<T>::infinity(), std::numeric_limits<unsigned int>::max() );
  unsigned int i = 0;
  for ( typename std::list<T>::const_iterator it = Arg.begin(); it != Arg.end(); ++it, ++i ) {
    if ( (*it) > (res.first) ) {
      res.first  = (*it);
      res.second = i;
    }
  }
  return ( res );
}

int main ( const int, const char** const ) {
  unsigned int size = 100;
  std::list<double> myList;
  for ( int i = 0; i < size; ++i ) {
    myList.push_back ( cos ( 0.47 * i + 0.11 ) );    // fill with some data
  }
  std::pair<double, unsigned int> maxAndPos = findMaximumAndItsPosition ( myList );
  std::cout << "Maximal value " << maxAndPos.first << " at position " << maxAndPos.second << std::endl;

  return ( EXIT_SUCCESS );
}
