#include<cstdlib>
#include<iostream>
#include<list>
#include<vector>
#include<algorithm>


struct ExpensiveToCreate {
  ExpensiveToCreate ( ) : _val ( 0 ) {
    std::cout << "  EXPENSIVE create" << std::endl;
  }

  ExpensiveToCreate ( const size_t Val ) : _val ( Val ) {
    std::cout << "  EXPENSIVE create" << std::endl;
  }

  ~ExpensiveToCreate ( ) {
    std::cout << "  EXPENSIVE destroy" << std::endl;
  }

  ExpensiveToCreate ( const ExpensiveToCreate& Other ) : _val ( Other._val ) {
    std::cout << "  EXPENSIVE copy" << std::endl;
  }

  ExpensiveToCreate& operator= ( const ExpensiveToCreate& Other ) {
    _val = Other._val;
    std::cout << "  EXPENSIVE assign" << std::endl;
    return ( *this );
  }

  bool operator< ( const ExpensiveToCreate& Other ) const {
    return ( ( this->_val < Other._val ) );
  }

private:
  size_t _val;
};


int main ( const int, const char** const ) {
  const size_t mySize = 4;
  {
    std::cout << "Creating and filling vector" << std::endl;
    std::vector<ExpensiveToCreate> myVector ( mySize );
    for ( size_t i = 0; i < mySize; ++i ) {
      myVector[i] = ExpensiveToCreate ( mySize - i );
    }
    std::cout << "sorting vector" << std::endl;
    std::sort ( myVector.begin(), myVector.end() );
    std::cout << "Done with vector" << std::endl;
  }
  std::cout << std::endl;

  {
    std::cout << "Creating and filling list" << std::endl;
    std::list<ExpensiveToCreate> myList;
    for ( size_t i = 0; i < mySize; ++i ) {
      myList.emplace_back ( i );
    }
    std::cout << "sorting list" << std::endl;
    myList.sort();
    std::cout << "Done with list" << std::endl;
  }

  return ( EXIT_SUCCESS );
}
