#include<cstdlib>
#include<iostream>
#include<vector>
#include<algorithm>

void fillWithSomeData ( std::vector<signed int> &Arg ) {
  const unsigned int destSize = 10;
  Arg.resize ( destSize );
  for ( unsigned int i = 0; i < destSize; ++i ) {
    Arg[i] = 42*i+23;
  }
}

void fillWithSomeOtherData ( std::vector<signed int> &Arg ) {
  const unsigned int destSize = 7;
  Arg.resize ( destSize );
  for ( unsigned int i = 0; i < destSize; ++i ) {
    Arg[i] = 19*i+41;
  }
}


template<typename ContainerType>
void printContainer ( const ContainerType &Arg ) {
  for ( auto it = Arg.begin(); it != Arg.end(); ++it ) {
    std::cout << *it << " ";
  }
  std::cout << std::endl;
}


int main ( const int, const char** const ) {

  // setup
  std::vector<signed int> myVecA, myVecB;
  fillWithSomeData ( myVecA );
  fillWithSomeOtherData ( myVecB );

  std::cout << "myVecA" << std::endl;
  printContainer ( myVecA );

  std::cout << "myVecB" << std::endl;
  printContainer ( myVecB );

  std::vector<signed int>::iterator destPos = myVecA.begin();
  ++destPos; ++destPos;
  myVecA.insert ( destPos, myVecB.rbegin(), myVecB.rend() );

  std::cout << "myVecA after insertion" << std::endl;
  printContainer ( myVecA );

  // delete values (not indices) 60 (included) … 275 (excluded!)
  signed int
    firstEntryToDelete = 60,
    firstEntryAfterDeletion = 275;

  std::vector<signed int>::iterator
    rangeBegin = std::find ( myVecA.begin(), myVecA.end(), firstEntryToDelete ),
    rangeEnd = std::find ( myVecA.begin(), myVecA.end(), firstEntryAfterDeletion );

  myVecA.erase ( rangeBegin, rangeEnd );

  printContainer ( myVecA );

  return ( EXIT_SUCCESS );
}
